# Bodies README.md

## Overview

The repository hosts design files for the OpenInterpreter's '01 Light` project, detailing two developmental versions of the hardware body. Version `v0` showcases an initial conceptual design, while version `v1` progresses towards a feature-complete prototype.

## Version Descriptions

### [v0](./bodies/v0)

- **Files**: `01 Light v0 - Bottom.stl`, `01 Light v0 - Top.stl`, `01 light v0.PNG`.
- **Design Intent**: Conceived as a prop, `v0` utilizes CA glue and neodymium magnets for a non-permanent assembly.

### [v1](./bodies/v1)

- **Files**: `01 Light v1 - Bottom.STL`, `01 Light v1 - Top.STL`, `01 Light v1.png`.
- **Design Intent**: As an early Proof of Concept (POC), `v1` aligns with the original BOM and features a screw-together assembly that necessitates support structures during 3D printing.
- **Development Status**: Treated as a Release Candidate, `v1` stands as the precursor to the production version. However, it is subject to further refinements.
- **Printing Recommendations**: For the top component, TPU is likely preferred to alleviate the button's stiffness. PLA and resin are alternatives, with the caveat that resin may not endure over time due to its brittle nature and toxicity.

## Community and Contributions

Your support on [Thingiverse](https://www.thingiverse.com/thing:6529845) and [Printables](https://www.printables.com/model/803461-01-light-version-1-the-worlds-first-language-model) helps us improve. Contributions, suggestions, and feedback are welcome via issue submission or pull requests.

## Upstream Documentation

For a comprehensive understanding of '01 Light`, refer to the [official documentation](https://01.openinterpreter.com/bodies/01-light).
